Qt 5.9 | Qt 3D | C++ Classes | QMorphPhongMaterial

Qt 5.9.9 Reference Documentation

# QMorphPhongMaterial Class

(Qt3DExtras::QMorphPhongMaterial)

The QMorphPhongMaterial class provides a default implementation of the phong lighting effect. More...

Header: | #include <QMorphPhongMaterial>
qmake: | QT += 3dextras
Since: | Qt 5.7
Inherits: | Qt3DRender::QMaterial

- List of all members, including inherited members

## Properties

- ambient : QColor
- diffuse : QColor
- interpolator : float

- shininess : float
- specular : QColor

- 1 property inherited from Qt3DRender::QMaterial
- 1 property inherited from Qt3DCore::QComponent
- 3 properties inherited from Qt3DCore::QNode

## Public Functions

| QMorphPhongMaterial(Qt3DCore::QNode *parent = nullptr)
| ~QMorphPhongMaterial()
QColor | ambient() const
QColor | diffuse() const
float | interpolator() const
float | shininess() const
QColor | specular() const

- 4 public functions inherited from Qt3DRender::QMaterial
- 2 public functions inherited from Qt3DCore::QComponent
- 11 public functions inherited from Qt3DCore::QNode

## Public Slots

void | setAmbient(const QColor &ambient)
void | setDiffuse(const QColor &diffuse)
void | setInterpolator(float interpolator)
void | setShininess(float shininess)
void | setSpecular(const QColor &specular)

- 1 public slot inherited from Qt3DRender::QMaterial
- 1 public slot inherited from Qt3DCore::QComponent
- 3 public slots inherited from Qt3DCore::QNode

## Signals

void | ambientChanged(const QColor &ambient)
void | diffuseChanged(const QColor &diffuse)
void | interpolatorChanged(float interpolator)
void | shininessChanged(float shininess)
void | specularChanged(const QColor &specular)

- 1 signal inherited from Qt3DRender::QMaterial
- 3 signals inherited from Qt3DCore::QComponent
- 4 signals inherited from Qt3DCore::QNode

### Additional Inherited Members

- 2 protected functions inherited from Qt3DCore::QNode

## Detailed Description

The QMorphPhongMaterial class provides a default implementation of the phong lighting effect.

The phong lighting effect is based on the combination of 3 lighting components ambient, diffuse and specular. The relative strengths of these components are controlled by means of their reflectivity coefficients which are modelled as RGB triplets:

- Ambient is the color that is emitted by an object without any other light source.
- Diffuse is the color that is emitted for rought surface reflections with the lights.
- Specular is the color emitted for shiny surface reflections with the lights.
- The shininess of a surface is controlled by a float property.

This material uses an effect with a single render pass approach and performs per fragment lighting. Techniques are provided for OpenGL 2, OpenGL 3 or above as well as OpenGL ES 2.

## Property Documentation

### ambient : QColor

Holds the ambient color.

Access functions:

QColor | ambient() const
void | setAmbient(const QColor &ambient)

Notifier signal:

void | ambientChanged(const QColor &ambient)

### diffuse : QColor

Holds the diffuse color.

Access functions:

QColor | diffuse() const
void | setDiffuse(const QColor &diffuse)

Notifier signal:

void | diffuseChanged(const QColor &diffuse)

### interpolator : float

Contains the interpolation method of the Phong lighting effect.

Access functions:

float | interpolator() const
void | setInterpolator(float interpolator)

Notifier signal:

void | interpolatorChanged(float interpolator)

### shininess : float

Holds the shininess exponent.

Access functions:

float | shininess() const
void | setShininess(float shininess)

Notifier signal:

void | shininessChanged(float shininess)

### specular : QColor

Holds the specular color.

Access functions:

QColor | specular() const
void | setSpecular(const QColor &specular)

Notifier signal:

void | specularChanged(const QColor &specular)

## Member Function Documentation

### QMorphPhongMaterial::QMorphPhongMaterial(Qt3DCore::QNode *parent = nullptr)

Default constructs an instance of QMorphPhongMaterial.

### QMorphPhongMaterial::~QMorphPhongMaterial()

Destroys the QMorphPhongMaterial.